/* Program som genererar ord frn suffixregler med hjlp av en ordlista */

/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

extern int GenereraFormer(unsigned char *line);
int xGrundform = 0; /* Skriv ut ordets grundform om xGrundform == 1 */

#define MAXNOOFFORBIDDENENDINGS 20

/* #include "stava.c" */
#include "suffix.c"

#ifdef WWWSTAVA
#ifdef stderr
#undef stderr
#endif
#define stderr stdout
#endif

#define GENFILE "/misc/tcs/language/stava/lexikon/saol/EL"

static void CreateFileName(char *filename)
{
  strcpy(filename, GENFILE);
}

/* NextRealWord letar efter nsta ord i s och stter start att peka p brjan av
 * det. Efter ordet stts '\0' in och efterfljande position returneras.
 * Om inget ord finns i s returneras NULL.
 * Ett ord fr innehlla bokstver och bindestreck. */
static unsigned char *NextRealWord(unsigned char *s, unsigned char **start)
{
  while (*s && *s < 'A') s++;
  if (*s == '\0') return NULL;
  *start = s;
  while (*s) {
    *s = ISO_intern[*s];
    if (!*s++) return s;
  }
  return s;
}


int GenereraFormer(unsigned char *line)
{ unsigned char word[LANGD], word1[LANGD], line1[200], *s, *start;
  unsigned char *wordsuffix, *suffix[20];
  char genfilename[FILENAMELENGTH];
  int accept[20], suffixLength[20];
  FILE *fp;
  int i, noOfSuf, noOfGeneratedWords, len, wordlen, checkvowel;
  unsigned char *t;
  char **p;
  int ending;
  char forbiddenlastcharacters[100], allowedlastcharacters[100];
  char *forbiddenending[MAXNOOFFORBIDDENENDINGS + 1];
  int forbiddenendinglength[MAXNOOFFORBIDDENENDINGS];
  CreateFileName(genfilename);
      forbiddenending[0] = '\0';
      forbiddenlastcharacters[0] = '\0';
      allowedlastcharacters[0] = '\0';
      len = strlen(line);
      if (line[len - 1] == '\n') line[--len] = '\0';
      strcpy(line1, line);
      s = line1;
      checkvowel = 1;
      if (*s == '<') {
	s++;
	if (*s == 'v' || *s == 'V') checkvowel = 1; else
	if (*s == 'b' || *s == 'B') checkvowel = 0; else
	{
#ifdef WWWSTAVA
	  fprintf(stderr, "Felaktigt &lt;*&gt;-uttryck.\n");
#else
	  fprintf(stderr, "Felaktigt <*>-uttryck.\n");
#endif
	  return 0;
	}
	while (*s && *s++ != '>');
      }
      if (*s == '(') {
	int last = 0, ending = 0;
	char *t;
	char **p = forbiddenending;
	s++;
	t = s; 
	do {
	  for (; *t && *t != ')' && *t != '|'; t++)
	    *t = ISO_intern[(unsigned char) (*t)];
	  if (*t) {
	    if (*t == ')') last = 1;
	    *t++ = '\0';
	    forbiddenendinglength[ending] = strlen(s);
	    *p++ = s;
	    s = t;
	  } else {
	    fprintf(stderr, "Fel i suffixtabellen. Oavslutat (*)-uttryck.\n");
	    break;
	  }
	} while (!last && ++ending < MAXNOOFFORBIDDENENDINGS);
	if (!last) {
	  if (ending >= MAXNOOFFORBIDDENENDINGS)
	    fprintf(stderr, 
		    "Fel i suffixtabellen. Fr mnga frbjudna ndelser.\n");
	  return 0; /* oavslutat (*)-uttryck */
	}
	*p = NULL;
      }      
      if (*s == '[') {
	int dis = 0;
	char *t;
	s++;
	if (*s == '^' || *s == '~') { dis = 1; s++; }
	for (t = s; *t && *t != ']'; t++)
	  *t = ISO_intern[(unsigned char) (*t)];
	if (*t) {
	  *t++ = '\0';
	  if (dis) strcpy(forbiddenlastcharacters, s);
	  else strcpy(allowedlastcharacters, s);
	  s = t;
	} else {
	  fprintf(stderr, "Oavslutat [*]-uttryck.\n");
	  return 0;
	}
      }      
      if ((s = NextWord(s, &start)) != NULL) {
	if (*start == '_') { /* negerad regel */
	  fprintf(stderr, "Negerad regel: %s. Ingen generering sker.\n",
		  line);
	  return 0;
	}
	wordsuffix = start;
	if ((s = NextWord(s, &start)) == NULL) {
	  fprintf(stderr,
		  "Suffixet %s saknar regler.\n",
		  wordsuffix);
	  return 0;
	}
	noOfSuf = 1;
	suffix[0] = NULL;
	do {
	  if (*start == '_') { /* negerat suffix */
	    accept[noOfSuf] = 0;
	    start++;
	    suffix[noOfSuf] = start;
	    suffixLength[noOfSuf] = strlen(start);
	    noOfSuf++;
	  } else {
	    if (suffix[0] == NULL && *start != '@') {
	      suffix[0] = start;
	      suffixLength[0] = strlen(start);
	    } else {
	      accept[noOfSuf] = 1;
	      suffix[noOfSuf] = start;
	      suffixLength[noOfSuf] = strlen(start);
	      noOfSuf++;
	    }
	  }
	} while ((s = NextWord(s, &start)) != NULL);
	if (suffix[0] == NULL) {
	  fprintf(stderr, "Bara negerade suffix fr regeln.\n");
	  return 0;
	}
	noOfGeneratedWords = 0;
	fp = fopen(genfilename, "r");
	if (fp == NULL) {
	  fprintf(stderr, "Kan inte ppna ordfilen.\n");
	  exit(1);
	}
	while (fgets(word, LANGD, fp)) {
	  len = strlen(word);
	  if (word[len - 1] == '\n') word[--len] = '\0';

	  if (NextRealWord(word, &start) == NULL) continue;
	  wordlen = strlen(word);
	  if (wordlen - suffixLength[0] < PREFIXMIN) continue;
	  if (!InEL(word, wordlen)) continue; /* om inte hela ordet lstes in gr vi vidare */
	  if (strcmp(word + wordlen - suffixLength[0], suffix[0]) == 0) {
	    strcpy(word1, word);
	    s = word1 + wordlen - suffixLength[0];
	    if (checkvowel) {
	      for (t = word1; t < s; t++)
		if (!isConsonant[(unsigned char) *t]) goto vowelsOK;
	      continue;
	    }
	  vowelsOK:

	    for (p = forbiddenending, ending = 0; *p; p++, ending++) {
	      i = forbiddenendinglength[ending];
	      if (strncmp(s - i, *p, i) == 0)
		goto continueonnextword;
	    }
	    if (*forbiddenlastcharacters) {
	      if (strchr(forbiddenlastcharacters, s[-1]) != NULL) continue;
	    } else if (*allowedlastcharacters) {
	      if (strchr(allowedlastcharacters, s[-1]) == NULL) continue;
	    }
	    for (i = 1; i < noOfSuf; i++) {
	      strcpy(s, suffix[i]);
	      if (InEL(word1,wordlen - suffixLength[0] + suffixLength[i])
		  != accept[i]) break;
	    }
	    if (i >= noOfSuf) {
	      strcpy(s, wordsuffix);

	      if (xGrundform == 1) WriteISO(word); else
		WriteISO(word1);
#ifdef WWWSTAVA
	      printf("<BR>");
#endif
	      printf("\n");
	      noOfGeneratedWords++;
	    }
	  }	
	continueonnextword: ;
	}
#ifdef WWWSTAVA
	printf("<P><B><PRE>");
#endif
	fprintf(stderr, "%d ord genereras av '%s'\n", noOfGeneratedWords, line);
#ifdef WWWSTAVA
	printf("</PRE></B>");
#endif
	fclose(fp);
      }
      return 1;
}
