/* Program som testar Stavas API. Det frvntar sej en textfil som
   kommandoradsargument och matar ut ord som anses vara felstavade.
   Rttstavningsfrslag ges.

   Copyright (C) Viggo Kann 2004-09-05
*/

/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "stavaapi.h"

int main(int argc, char **argv)
{ unsigned char buf[100];
  FILE *fp;
  if (argc < 2) {
    fprintf(stderr, "Syntax:   %s filnamn\n", argv[0]);
    exit(1);
  }
  fp = fopen(argv[1], "r");
  if (!fp) {  
    fprintf(stderr, "Kan inte ppna filen %s\n", argv[1]);
    exit(1);
  }
  if (!StavaReadLexicon(LIBPATH,1,1,0,0,0,1,(const unsigned char *) ",")) {
    fprintf(stderr, "Kan inte initiera Stava\n");
    exit(1);
  }
  xGenerateCompounds = 1;
  while (StavaGetWord(fp, buf)) {
    if (!StavaWord(buf)) {
      unsigned char *corrections = StavaCorrectWord(buf);
      if (corrections) {
	printf("%s: %s\n", buf, corrections);
	free(corrections);
      }
    }
  }
  return 0;
}
