/* Program som testar Stavas API. Det frvntar sej ett ord
   per rad och matar ut ord som anses vara felstavade.
   Rttstavningsfrslag ges.

   Copyright (C) Viggo Kann 2002-03-22
*/

/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "stavaapi.h"

int main(void)
{ char buf[100];
  if (!StavaReadLexicon(LIBPATH,1,1,0,0,0,1,(const unsigned char *) ",")) {
    fprintf(stderr, "Kan inte initiera Stava\n");
    exit(1);
  }
  xGenerateCompounds = 1;
  while (gets(buf)) {
    if (!StavaWord((unsigned char *) buf)) {
      unsigned char *corrections = StavaCorrectWord((unsigned char *) buf);
      if (corrections) {
	printf("%s: %s\n", buf, corrections);
	free(corrections);
      }
    }
  }
  return 0;
}
